#! /usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const commander_jsx_1 = require("commander-jsx");
const fs_1 = require("fs");
const core_1 = require("./core");
async function match({ 'ini-file': iniFile, 'NPM-config': NPMConfig }, ...list) {
    const show_log = iniFile || NPMConfig;
    if (show_log)
        console.time('Search');
    for (const name of list) {
        const path = await (0, core_1.which)(name);
        console.info((show_log || list[1] ? `${name}=` : '') + path);
        if (iniFile || NPMConfig)
            (0, fs_1.appendFileSync)(iniFile || '.env', `${name}=${path}\n`);
    }
    if (!show_log)
        return;
    console.info('--------------------');
    console.timeEnd('Search');
}
commander_jsx_1.Command.execute((0, commander_jsx_1.createCommand)(commander_jsx_1.Command, { parameters: "[name ...]", description: "Search App paths with App Name", options: {
        'ini-file': {
            shortcut: 'f',
            parameters: '<path>',
            description: 'Append result to an ini-like file'
        },
        'NPM-config': {
            shortcut: 'c',
            description: 'Append result to ".env" file in working directory (since npm@9 & fs-match@1.7)'
        }
    }, executor: match }), process.argv.slice(2));
