"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPartition = getPartition;
exports.getAppFolder = getAppFolder;
const fs_1 = require("fs");
const { env } = process;
let disk;
/**
 * @return  Acessible disk partitions of current Windows
 */
function getPartition() {
    return (disk ||
        (disk = 'CDEFGHIJKLMNOPQRSTUVWXYZ'
            .split('')
            .map(disk => {
            disk = `${disk}:\\`;
            if ((0, fs_1.existsSync)(disk) && (0, fs_1.readdirSync)(disk)[2])
                return disk;
        })
            .filter(Boolean)));
}
let folder;
/**
 * @return  Acessible application folders of current Windows
 */
function getAppFolder() {
    return (folder ||
        (folder = getPartition()
            .map(disk => [
            env.PROGRAMFILES,
            env['ProgramFiles(x86)'],
            env.LOCALAPPDATA
        ].filter(path => (0, fs_1.existsSync)((path = disk + path.slice(3)))))
            .flat()));
}
